program NkMon;

{$R *.RES}

uses NLib, NSys, NForm, NConf, Default, MainForm, Monitor;

var
  opt: WideChar;
begin
  App.Name := 'NkMon';

  ProfDir := GetEnv('NKTOOLSPROF');
  if ProfDir = '' then
    ProfDir := DirName(ProgPath)
  else
    ProfDir := JoinPath([ProfDir, 'nkmon']);

  with ArgParser do
  begin
    while GetOpt(opt) do
      case opt of
        'd': ProfDir := GetArg;
        'p': Monitor.UdpReceiverPort := SInt(GetArg);
      else
        App.Error('usage: nkmon [-d profdir] [-p port]');
        Exit;
      end;
    Argv := Args;
  end;

  ProfDir := AbsPath(ProfDir);
  try
    with TListDir.Create(ProfDir) do
      Free;
  except
    on E: EOSError do
      App.Error(FormatException(E));
  end;

  Config := TConf.Create;
  Config.Read(Default.Config);
  Config.LoadFromFile(JoinPath([ProfDir, 'position']));
  Config.LoadFromFile(JoinPath([ProfDir, 'config']));

  App.MainForm := TNkMonMainForm.Create;
  ExitCode := App.Run;

  App.MainForm.Free;
  Config.Free;
end.
