unit Iphlpapi;

interface

uses Windows;

const
  MAX_HOSTNAME_LEN = 128;
  MAX_SCOPE_ID_LEN = 256;
  MAX_INTERFACE_NAME_LEN = 256;
  MAXLEN_IFDESCR = 256;
  MAXLEN_PHYSADDR = 8;

type
  PIpAddressString = ^TIpAddressString;
  TIpAddressString = record
    String_: array [0..4*4-1] of Char;
  end;
  PIpMaskString = ^TIpMaskString;
  TIpMaskString = TIpAddressString;

  PIpAddrString = ^TIpAddrString;
  TIpAddrString = record
    Next: PIpAddrString;
    IpAddress: TIpAddressString;
    IpMask: TIpMaskString;
    Context: DWORD;
  end;

  PFixedInfo = ^TFixedInfo;
  TFixedInfo = record
    HostName: array [0..MAX_HOSTNAME_LEN+4-1] of Char;
    DomainName: array [0..MAX_HOSTNAME_LEN+4-1] of Char;
    CurrentDnsServer: PIpAddrString;
    DnsServerList: TIpAddrString;
    NodeType: UINT;
    ScopeId: array [0..MAX_SCOPE_ID_LEN+4-1] of Char;
    EnableRouting: UINT;
    EnableProxy: UINT;
    EnableDns: UINT;
  end;

  PMibIfRow = ^TMibIfRow;
  TMibIfRow = record
    wszName: array [0..MAX_INTERFACE_NAME_LEN-1] of WCHAR;
    dwIndex: DWORD;
    dwType: DWORD;
    dwMtu: DWORD;
    dwSpeed: DWORD;
    dwPhysAddrLen: DWORD;
    bPhysAddr: array [0..MAXLEN_PHYSADDR-1] of Byte;
    dwAdminStatus: DWORD;
    dwOperStatus: DWORD;
    dwLastChange: DWORD;
    dwInOctets: DWORD;
    dwInUcastPkts: DWORD;
    dwInNUcastPkts: DWORD;
    dwInDiscards: DWORD;
    dwInErrors: DWORD;
    dwInUnknownProtos: DWORD;
    dwOutOctets: DWORD;
    dwOutUcastPkts: DWORD;
    dwOutNUcastPkts: DWORD;
    dwOutDiscards: DWORD;
    dwOutErrors: DWORD;
    dwOutQLen: DWORD;
    dwDescrLen: DWORD;
    bDescr: array[0..MAXLEN_IFDESCR-1] of Byte;
  end;

  PMibIfTable = ^TMibIfTable;
  TMibIfTable = record
    dwNumEntries: DWORD;
    table: array [0..0] of TMibIfRow;
  end;

  PMibIpAddrRow = ^TMibIpAddrRow;
  TMibIpAddrRow = record
    dwAddr: DWORD;
    dwIndex: DWORD;
    dwMask: DWORD;
    dwBCastAddr: DWORD;
    dwReasmSize: DWORD;
    unused1: Word;
    wType: Word;
  end;

  PMibIpAddrTable = ^TMibIpAddrTable;
  TMibIpAddrTable = record
    dwNumEntries: DWORD;
    table: array [0..0] of TMibIpAddrRow;
  end;

  PMibTcpRow = ^TMibTcpRow;
  TMibTcpRow = record
    dwState: DWORD;
    dwLocalAddr: DWORD;
    dwLocalPort: DWORD;
    dwRemoteAddr: DWORD;
    dwRemotePort: DWORD;
  end;
  PMibTcpTable = ^TMibTcpTable;
  TMibTcpTable = record
    dwNumEntries: DWORD;
    table: array [0..0] of TMibTcpRow;
  end;

  PMibTcpRowOwnerPid = ^TMibTcpRowOwnerPid;
  TMibTcpRowOwnerPid = record
    dwState: DWORD;
    dwLocalAddr: DWORD;
    dwLocalPort: DWORD;
    dwRemoteAddr: DWORD;
    dwRemotePort: DWORD;
    dwOwningPid: DWORD;
  end;
  PMibTcpTableOwnerPid = ^TMibTcpTableOwnerPid;
  TMibTcpTableOwnerPid = record
    dwNumEntries: DWORD;
    table: array [0..0] of TMibTcpRowOwnerPid;
  end;

  PMibTcpStats = ^TMibTcpStats;
  TMibTcpStats = record
    dwRtoAlgorithm: DWORD;
    dwRtoMin: DWORD;
    dwRtoMax: DWORD;
    dwMaxConn: DWORD;
    dwActiveOpens: DWORD;
    dwPassiveOpens: DWORD;
    dwAttemptFails: DWORD;
    dwEstabResets: DWORD;
    dwCurrEstab: DWORD;
    dwInSegs: DWORD;
    dwOutSegs: DWORD;
    dwRetransSegs: DWORD;
    dwInErrs: DWORD;
    dwOutRsts: DWORD;
    dwNumConns: DWORD;
  end;

  PMibUdpRow = ^TMibUdpRow;
  TMibUdpRow = record
    dwLocalAddr: DWORD;
    dwLocalPort: DWORD;
  end;

  PMibUdpTable = ^TMibUdpTable;
  TMibUdpTable = record
    dwNumEntries: DWORD;
    table: array [0..0] of TMibUdpRow;
  end;

  PMibUdpRowOwnerPid = ^TMibUdpRowOwnerPid;
  TMibUdpRowOwnerPid = record
    dwLocalAddr: DWORD;
    dwLocalPort: DWORD;
    dwOwningPid: DWORD;
  end;
  PMibUdpTableOwnerPid = ^TMibUdpTableOwnerPid;
  TMibUdpTableOwnerPid = record
    dwNumEntries: DWORD;
    table: array [0..0] of TMibUdpRowOwnerPid;
  end;

  PMibUdpStats = ^TMibUdpStats;
  TMibUdpStats = record
    dwInDatagrams: DWORD;
    dwNoPorts: DWORD;
    dwInErrors: DWORD;
    dwOutDatagrams: DWORD;
    dwNumAddrs: DWORD;
  end;

  TCP_TABLE_CLASS = (
    TCP_TABLE_BASIC_LISTENER,
    TCP_TABLE_BASIC_CONNECTIONS,
    TCP_TABLE_BASIC_ALL,
    TCP_TABLE_OWNER_PID_LISTENER,
    TCP_TABLE_OWNER_PID_CONNECTIONS,
    TCP_TABLE_OWNER_PID_ALL,
    TCP_TABLE_OWNER_MODULE_LISTENER,
    TCP_TABLE_OWNER_MODULE_CONNECTIONS,
    TCP_TABLE_OWNER_MODULE_ALL
  );

  UDP_TABLE_CLASS = (
    UDP_TABLE_BASIC,
    UDP_TABLE_OWNER_PID,
    UDP_TABLE_OWNER_MODULE
  );

var
  GetExtendedTcpTable: function (pTcpTable: Pointer; var pdwSize: PDWORD;
      bOrder: BOOL; ulAf: ULONG; TableClass: TCP_TABLE_CLASS; Reserved: ULONG):
      DWORD; stdcall;
  GetExtendedUdpTable: function (pUdpTable: Pointer; var pdwSize: PDWORD;
      bOrder: BOOL; ulAf: ULONG; TableClass: UDP_TABLE_CLASS; Reserved: ULONG):
      DWORD; stdcall;
  GetIfTable: function (pIfTable: PMibIfTable; var pdwSize: ULONG;
      bOrder: BOOL): DWORD; stdcall;
  GetIpAddrTable: function (pIpAddrTable: PMibIpAddrTable; var pdwSize: ULONG;
      bOrder: BOOL): DWORD; stdcall;
  GetNetworkParams: function (pFixedInfo: PFixedInfo; var OutBufLen: ULONG):
      DWORD; stdcall;
  GetTcpTable: function (pTcpTable: PMibTcpTable; var pdwSize: DWORD;
      bOrder: BOOL): DWORD; stdcall;
  GetTcpStatistics: function (var Stats: TMibTcpStats): DWORD; stdcall;
  GetUdpTable: function (pUdpTable: PMibUdpTable; var pdwSize: DWORD;
      bOrder: BOOL): DWORD; stdcall;
  GetUdpStatistics: function (var Stats: TMibUdpStats): DWORD; stdcall;

implementation

var
  dir: WideString;
  h: HMODULE;
begin
  SetString(dir, nil, GetSystemDirectoryW(nil, 0));
  if GetSystemDirectoryW(PWideChar(dir), Length(dir)) = 0 then
    Exit;
  SetLength(dir, Length(dir)-1); // -1 for terminating null character
  h := LoadLibraryW(PWideChar(dir + '\iphlpapi.dll'));
  if h = 0 then
    Exit;
  GetExtendedTcpTable := GetProcAddress(h, 'GetExtendedTcpTable');
  GetExtendedUdpTable := GetProcAddress(h, 'GetExtendedUdpTable');
  GetIfTable := GetProcAddress(h, 'GetIfTable');
  GetIpAddrTable := GetProcAddress(h, 'GetIpAddrTable');
  GetNetworkParams := GetProcAddress(h, 'GetNetworkParams');
  GetTcpTable := GetProcAddress(h, 'GetTcpTable');
  GetTcpStatistics := GetProcAddress(h, 'GetTcpStatistics');
  GetUdpTable := GetProcAddress(h, 'GetUdpTable');
  GetUdpStatistics := GetProcAddress(h, 'GetUdpStatistics');
end.
