unit NDesktop;

interface

uses NGraphics;

procedure Open(const Args: array of WideString);
procedure LoadFileIcon(const Icon: TIcon; const Path: WideString; Index: Integer=1);
procedure OpenDir(const Path: WideString);

implementation

uses Windows, ShellAPI, NLib, NSys;

procedure Open(const Args: array of WideString);
var
  i: Integer;
  base, path: WideString;
begin
  base := BaseName(Args[0]);
  // XP needs '\'
  path := Args[0]; // WideString always copyed
  for i := 1 to Length(path) do
    if path[i] = '/' then path[i] := '\';
  if (base = '.') or (base = '..') then
    path := path +  '\';
  if ShellExecuteW(GetDesktopWindow, nil, PWideChar(Path),
      PWideChar(JoinCommandLine(SliceArray(Args, 1))), nil,
      SW_SHOWNORMAL) <= 32 then
    raise EOSError.Create;
end;

// Index=1 to get a normal file icon instead of a thumbnail icon
procedure LoadFileIcon(const Icon: TIcon; const Path: WideString; Index: Integer=1);
var
  buf: array[0..MAX_PATH] of WideChar;
  i: Word;
  len: Integer;
begin
  if Icon.Handle <> 0 then
    DestroyIcon(Icon.Handle);
  len := Length(Path) * SizeOf(WideChar);
  if len < SizeOf(buf) then
  begin
    FillChar(buf, SizeOf(buf), 0);
    Move(Path[1], buf, len);
    i := Index;
    Icon.Handle := ExtractAssociatedIconW(HInstance, buf, i);
  end else
    Icon.Handle := 0;
end;

procedure OpenDir(const Path: WideString);
begin
  if ShellExecuteW(GetDesktopWindow, 'open',
      PWideChar(GetEnv('windir')+'\explorer.exe'),
      PWideChar('/select,"'+Path+'"'),
      nil, SW_SHOWNORMAL) <= 32 then
    raise EOSError.Create;
end;

end.
