unit PdhSub;

interface

uses Windows;

const
  PDH_NO_DATA = $800007D5;
  PDH_MEMORY_ALLOCATION_FAILURE = $C0000BBB;
  PDH_INVALID_HANDLE = $C0000BBC;
  PDH_INVALID_ARGUMENT  = $C0000BBD;

  PDH_FMT_RAW      = $00000010;
  PDH_FMT_ANSI     = $00000020;
  PDH_FMT_UNICODE  = $00000040;
  PDH_FMT_LONG     = $00000100;
  PDH_FMT_DOUBLE   = $00000200;
  PDH_FMT_LARGE    = $00000400;
  PDH_FMT_NOSCALE  = $00001000;
  PDH_FMT_1000     = $00002000;
  PDH_FMT_NODATA   = $00004000;
  PDH_FMT_NOCAP100 = $00008000;

type
  HQUERY = THandle;
  HCOUNTER = THandle;
  PDH_STATUS = Longint;
  TPdhFmtCounterValue = record
    CStatus : DWORD;
    case Integer of
      0: (dummy0: Longint; longValue  : Longint;);
      1: (doubleValue: Double);
      2: (largeValue: LONGLONG);
      3: (dummy1: Longint; AnsiStringValue: LPCSTR);
      4: (dummy2: Longint; WideStringValue: LPCWSTR);
  end;

var
  PdhOpenQuery: function (pReserved: Pointer; dwUserData: DWORD;
      var hQuery: HQUERY): PDH_STATUS; stdcall;
  PdhCloseQuery: function (hQuery: HQUERY): PDH_STATUS; stdcall;
  PdhAddCounter: function (hQuery: HQUERY; szFullCounterPath: PChar;
      dwUserData: DWORD; var hCounter: HCOUNTER): PDH_STATUS; stdcall;
  PdhRemoveCounter: function(hCounter: HCOUNTER): PDH_STATUS; stdcall;
  PdhCollectQueryData: function(hQuery: HQUERY): PDH_STATUS; stdcall;
  PdhGetFormattedCounterValue: function(hCounter: HCOUNTER; dwFormat: DWORD;
      lpdwType: LPDWORD; var Value: TPdhFmtCounterValue): PDH_STATUS; stdcall;

implementation

var
  dir: WideString;
  h: HMODULE;
begin
  SetString(dir, nil, GetSystemDirectoryW(nil, 0));
  if GetSystemDirectoryW(PWideChar(dir), Length(dir)) = 0 then
    Exit;
  SetLength(dir, Length(dir)-1); // -1 for terminating null character
  h := LoadLibraryW(PWideChar(dir + '\pdh.dll'));
  if h = 0 then
    Exit;
  PdhOpenQuery := GetProcAddress(h, 'PdhOpenQuery');
  PdhCloseQuery := GetProcAddress(h, 'PdhCloseQuery');
  PdhAddCounter := GetProcAddress(h, 'PdhAddCounterA');
  PdhRemoveCounter := GetProcAddress(h, 'PdhRemoveCounter');
  PdhCollectQueryData := GetProcAddress(h, 'PdhCollectQueryData');
  PdhGetFormattedCounterValue := GetProcAddress(h, 'PdhGetFormattedCounterValue');
end.
