program mkversion;

uses NLib, NSys, NStdIO;

function StripLineSep(const S: string): string;
begin
  Result := s;
  if Result[Length(Result)] = #10 then
  begin
    SetLength(Result, Length(Result)-1);
    if Result[Length(Result)] = #13 then
      SetLength(Result, Length(Result)-1);
  end;
end;

var
  i: Integer;
  verstr, ver, copyright, builddate: string;
begin
  try
    StdIn.ReadLine(verstr);
    StdIn.ReadLine(copyright);

    verstr := StripLineSep(verstr);
    ver := verstr;
    for i := 1 to Length(ver) do
      if ver[i] = '.' then ver[i] := ',';
    copyright := StripLineSep(copyright);
    with LocalTime(Time) do
      builddate := Format('{0}{1:02}{2:02}', [Year, Mon, MDay]);

    Print('#define VER_PRODUCTVER ' + ver);
    Print('#define VER_PRODUCTVERSTR "' + verstr + '\0"');
    Print('#define VER_FILEVER ' + ver);
    Print('#define VER_FILEVERSTR "' + verstr + '\0"');
    Print('#define VER_COPYRIGHT "'+ copyright + '\0"');
    Print('#define PRODUCTVERDATE "' + verstr + ' ('+builddate+')'+'"');
    Print('#define COPYRIGHT "'+ copyright + '"');
  except
    SysFatal;
  end;
end.
